unit UFormSettings;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TFormSettings }

  TFormSettings = class(TForm)
    ButtonCancel: TButton;
    ButtonOk: TButton;
    ComboBoxLanguage: TComboBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private

  public
    procedure Load;
    procedure Save;
  end;

var
  FormSettings: TFormSettings;

implementation

{$R *.lfm}

uses
  UCore, ULanguages;

{ TFormSettings }

procedure TFormSettings.FormCreate(Sender: TObject);
begin
  Core.CoolTranslator1.TranslateComponentRecursive(Self);
  Core.CoolTranslator1.LanguageListToStrings(ComboBoxLanguage.Items);
end;

procedure TFormSettings.Load;
begin
  ComboBoxLanguage.ItemIndex := ComboBoxLanguage.Items.IndexOfObject(Core.CoolTranslator1.Language);
  if ComboBoxLanguage.ItemIndex = -1 then ComboBoxLanguage.ItemIndex := 0;
end;

procedure TFormSettings.Save;
begin
  if ComboBoxLanguage.ItemIndex <> -1 then
    Core.CoolTranslator1.Language := TLanguage(ComboBoxLanguage.Items.Objects[ComboBoxLanguage.ItemIndex]);
end;

end.

