unit UCore;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, XMLConf, FileUtil, Controls, ActnList, UGrammer,
  UPersistentForm, ULastOpenedList, UApplicationInfo, UCoolTranslator;

type

  { TCore }

  TCore = class(TDataModule)
    ApplicationInfo1: TApplicationInfo;
    CoolTranslator1: TCoolTranslator;
    ImageList1: TImageList;
    PersistentForm1: TPersistentForm;
    XMLConfig1: TXMLConfig;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { private declarations }
  public
    ReopenLastFile: Boolean;
    Grammer: TGrammer;
    procedure LoadConfig;
    procedure SaveConfig;
    procedure Initialize;
    procedure Finalize;
  end;

var
  Core: TCore;

implementation

{$R *.lfm}

uses
  UFormMain;

{ TCore }

procedure TCore.DataModuleCreate(Sender: TObject);
begin
  ForceDirectories(GetAppConfigDir(False));
  XMLConfig1.Filename := GetAppConfigDir(False) + 'Config.xml';
end;

procedure TCore.DataModuleDestroy(Sender: TObject);
begin
end;

procedure TCore.LoadConfig;
begin
  with XMLConfig1 do begin
    ReopenLastFile := GetValue('ReopenLastFile', True);
    CoolTranslator1.Language := CoolTranslator1.Languages.SearchByCode(String(GetValue('Language', '')));
  end;
end;

procedure TCore.SaveConfig;
begin
  with XMLConfig1 do begin
    SetValue('ReopenLastFile', ReopenLastFile);
    SetValue('Language', WideString(CoolTranslator1.Language.Code));
    Flush;
  end;
end;

procedure TCore.Initialize;
begin
  PersistentForm1.RegistryContext := ApplicationInfo1.GetRegistryContext;
  LoadConfig;
  FormMain.LoadConfig(XMLConfig1);
  if ReopenLastFile and FileExists(FormMain.LastOpenedList1.GetFirstFileName) then
    FormMain.ProjectOpen(FormMain.LastOpenedList1.GetFirstFileName)
    else FormMain.AProjectNew.Execute;
end;

procedure TCore.Finalize;
begin
  FormMain.SaveConfig(XMLConfig1);
  SaveConfig;
end;

end.

